package ksu.cis.collaboration;

import java.awt.event.*;
import java.io.*;
import java.net.*;
import ksu.cis.mom.*;
import ksu.cis.collaboration.gui.*;
/**
 * This type was created in VisualAge.
 */
public class ClientAgent extends Agent implements ActionListener {
	public String serverHost;
	public int serverPort;
	public WindowBase w;
/**
 * ClientAgent constructor comment.
 */
public ClientAgent(String agentName, int agentPort, String sHost, int sPort)
{
	super(agentName, agentPort);
	this.serverHost = sHost; // the Host to connect to
	this.serverPort = sPort; // the Port to connect to

	/* server initialization */

	MessageHandler h = new MessageHandler(this.port, this);
	h.start();

	/* window initialization */

	w = new WindowBase(this);
	w.run();
}
/**
 * This method was created in VisualAge.
 * @param e java.awt.event.ActionEvent
 */
public void actionPerformed(ActionEvent e)
{
	if (e.getActionCommand().equals("Exit"))
	{
		System.exit(0);
	} 
	else
		write("Error in memo interface!");

}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 * @param iType java.lang.String
 */
public String find_info_type(String iType)
{
	return(w.find_info_type(iType));
}
/**
 * ... only for testing purposes until we GUI
 */
public String get_askinfoType()
{
	if (this.name.equals("Client-2"))
		return "Laundry";
	if (this.name.equals("Client-3"))
		return "Dry Cleaning";
	if (this.name.equals("Client-1"))
		return "Drill Press Operator";
	else
		return "Unknown";
}
/**
 * ... only for testing purposes until we GUI
 */
public String get_infoType()
{
	if (this.name.equals("Client-1"))
		return "Laundry";
	if (this.name.equals("Client-2"))
		return "Dry Cleaning";
	if (this.name.equals("Client-3"))
		return "Drill Press Operator";
	else
		return "Unknown";
}
/**
 * This method was created in VisualAge.
 * @param args java.lang.String[]
 * Hartrum: added command line arguments:
 *    java ClientAgent                      - uses both defaults.
 *    java ClientAgent host                 - sets host w/ default ports.
 *    java ClientAgent host hostport        - sets both host, local default.
 *    java ClientAgent host hostport myport - sets all three.
 */
public static void main(String[] args) {

	// Set default values.
	String serverHost = "localhost";
	int serverPort = 5001;
	int localPort = 3001; //Added 03/31/00.

	// Added 03/31/00 ****************************
	if (args.length > 0)
		serverHost = args[0];
	if (args.length > 1) {
		try {
			serverPort = Integer.parseInt(args[1]);
			if (args.length == 3)
				localPort = Integer.parseInt(args[2]);
		} catch (NumberFormatException e) {
		}
	}
	System.out.println("Calling " + serverHost + " port " + serverPort + " from local port " + localPort + ".");
	// End add 03/31/00 ****************************

	/* start new client agent */
	ClientAgent s = new ClientAgent("Client", localPort, serverHost, serverPort);
	s.run();
}
/**
 * receiveMessage method comment.
 */
public void receiveMessage(Socket server, ObjectInputStream input, ObjectOutputStream output)
{
	int i;
	Message m;
	Thread t;

	/* define all possible conversations receivable here */

	try
	{
		m = (Message) input.readObject();
		write("Received message " + m.performative + " from " + m.sender);
		if (m.performative.equals("request"))
		{
			t = new Thread(new Provider_Request_Info(server, input, output, this, m));
			t.start(); // start new thread
		} else
			if (m.performative.equals("send"))
			{
				t = new Thread(new Client_Return_Info_Source(server, input, output, this, m));
				t.start(); // start new thread
			} else
			{
				write(" ** Invalid Attempt to start new conversation with performative " + m.performative + " from " + m.sender);
				t = new Thread(new Sorry(server, input, output, this, m));
				t.start(); // start new thread 
			}
	} catch (ClassNotFoundException cnfex)
	{
		write(" ** ClassNotFoundException ");
	} catch (IOException cnfex)
	{
		write(" ** IOException on port (ServerAgent.receiveMessage)");
	}
}
/**
 * This method was created in VisualAge.
 * @param args java.lang.String[]
 */
public void run() {
	/*
	Thread init;
	write("Starting Client");
	setVisible(true);
	//
	
	init = new Thread(new Client_Register_Info_Source(this, serverHost, serverPort, get_infoType()));
	init.start();
	//
	
	int j;
	for (int i = 0; i < 10000000; i++)
	j = i - 1;
	//
	
	if (name.equals("Client-2"))
	{
	init = new Thread(new Client_Register_For_Info(this, serverHost, serverPort, get_askinfoType()));
	init.start();
	} else
	{
	init = new Thread(new Client_Request_Info_Source(this, serverHost, serverPort, get_askinfoType()));
	init.start();
	}
	//
	
	for (int i = 0; i < 10000000; i++)
	j = i - 1;
	//
	
	for (int i = 0; i < 10000000; i++)
	j = i - 1;
	//
	
	init = new Thread(new Client_Deregister_Info_Source(this, serverHost, serverPort, get_infoType()));
	init.start();
	init = new Thread(new Client_Deregister_For_Info(this, serverHost, serverPort, get_askinfoType()));
	init.start();
	
	*/
}
/**
 * This method was created in VisualAge.
 * @param infoType java.lang.String
 * @param info java.lang.String
 */
public void save_info(String infoType, String info)
{
	w.addToList(infoType, info); 
}
/**
 * This method was created in VisualAge.
 * @param infoType java.lang.String
 * @param info java.lang.String
 */
public void saveInfoSource(InfoType_Source source)
{
	w.addToList2(source);
}
/**
 * This method was created in VisualAge.
 * @param s java.lang.String
 */
public void write(String s)
{
	System.out.println(s);
}
}
