package ksu.cis.collaboration;

/**
 * This type was created in VisualAge.
 */
import java.net.*;
import java.io.*;
import ksu.cis.mom.*;
public class Client_Deregister_Info_Source extends Conversation
{
	ClientAgent parent; // override parent
	String service;
/**
 * Server_Register constructor comment.
 */
public Client_Deregister_Info_Source(ClientAgent a, String hostName, 
	int portNum, String theService)
{
	super(a, hostName, portNum);
	parent = a;
	service = theService;
}
/**
 * This method was created in VisualAge.
 */
public void run() {
	Message m = new Message();
	int state = 0;
	boolean notDone = true;
	parent.write("Starting Client_Deregister_Info_Source conversation.");

	//set up conversation
	try {
		connection = new Socket(connectionHost, connectionPort);
		output = new ObjectOutputStream(connection.getOutputStream());
		output.flush();
		input = new ObjectInputStream(connection.getInputStream());
		while (notDone) {
			switch (state) {
				case 0 :
					m.setPerformative("deregister_all");
					m.content = service;
					sendMessage(m, output);
					state = 1;
					break;
				case 1 :
					m = readMessage(input);
					if (m.performative.equals("acknowledge"))
						notDone = false;
					else
						parent.write("** ERROR - did not get reply back ** \n");
					break;
			}
		}
		parent.write("Ending Client_Deregister_Info_Source conversation.");
		input.close();
		output.close();
		connection.close();
	} catch (UnknownHostException e) {
		parent.write("** Unknown Host exception in Client_Deregister_Info_Source.");
	} catch (EOFException oef) {
		parent.write("** Server terminated connection in Client_Deregister_Info_Source.");
	} catch (IOException e) {
		parent.write("** IO Exception in Client_Deregister_Info_Source.");
		e.printStackTrace();
	}
}
}
