package ksu.cis.collaboration.gui;

/**
 * This type was created in VisualAge.
 */
import javax.swing.*;
import java.awt.event.*;
import java.util.*;
import ksu.cis.collaboration.*;

public class WindowBase extends JFrame implements ActionListener
{
	private JPanel ivjJFrameContentPane = null;
	private JList ivjJList1 = null;
	private JButton ivjAddToListButton = null;
	private JTextField ivjInfo = null;
	private JLabel ivjInfoLabel = null;
	private JTextField ivjType = null;
	private JLabel ivjTypeLabel = null;
	private JList ivjJList2 = null;
	private JTextField ivjName = null;
	private JTextField ivjPort = null;
	private JLabel ivjNameLabel = null;
	private JLabel ivjPortLabel = null;
	private JButton ivjReadButton = null;
	private JButton ivjRegInfoButton = null;
	private JButton ivjRegReqButton = null;
	private JButton ivjReqInfoButton = null;
	private JButton ivjReqSource = null;
	private Vector list1 = new Vector();
	private Vector list2 = new Vector();
	private JScrollPane ivjJScrollPane1 = null;
	private JScrollPane ivjJScrollPane2 = null; //

	private ClientAgent parent;

/**
 * Constructor
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public WindowBase() {
	super();
	initialize();
}
/**
 * Constructor
 */
public WindowBase(ClientAgent a)
{
	super();
	initialize();
	parent = a;

	ivjName.setText(parent.name);
	ivjPort.setText(parent.port + "");
}
/**
 * Method to handle events for the ActionListener interface.
 * @param e java.awt.event.ActionEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public void actionPerformed(java.awt.event.ActionEvent e)
{
	if ((e.getSource() == getAddToListButton()))
		addToList();
	else
		if ((e.getSource() == getReadButton()))
		{
			read();
		} else
			if ((e.getSource() == getRegInfoButton()))
			{
				regInfo();
			} else
				if ((e.getSource() == getReqSource()))
				{
					RequestFrame request = new RequestFrame(parent, "Request");
					request.show();
				} else
					if ((e.getSource() == getRegReqButton()))
					{
						RequestFrame request = new RequestFrame(parent, "RegRequest");
						request.show();
					} else
						if ((e.getSource() == getReqInfoButton()))
						{
							requestInfo();
						}
						// user code begin {2}
						// user code end
}
/**
 * This method was created in VisualAge.
 */
public void addToList()
{
	addToList(getType().getText(), getInfo().getText());
/*	Information next = new Information(getType().getText(), getInfo().getText());
	list1.addElement(next);
	ivjJList1.setListData(list1);
	ivjJList1.setCellRenderer(new MyCellRenderer());
*/
	this.repaint();
}
/**
 * This method was created in VisualAge.
 */
public void addToList(String infoType, String info)
{
	Information next = new Information(infoType, info);
	list1.addElement(next);
	ivjJList1.setListData(list1);
	ivjJList1.setCellRenderer(new MyCellRenderer());

	this.repaint();
}
/**
 * This method was created in VisualAge.
 */
public void addToList2(InfoType_Source source)
{
	/* For adding info the list of sources */

	Source s = new Source("", source.host, source.port);
	SourceInfo sInfo = new SourceInfo(source.infoType, s); 
	list2.addElement(sInfo);
	ivjJList2.setListData(list2);
	ivjJList2.setCellRenderer(new MyCellRenderer2());

	this.repaint();
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 * @param iType java.lang.String
 */
public String find_info_type(String iType)
{
	Enumeration e = list1.elements();
	while (e.hasMoreElements())
	{
		try
		{
			Information i = (Information) e.nextElement();
			if (i.type.equals(iType))
			{
				System.out.println(" Found information " + i.info + " of type: " + i.type);
				return(i.info);
			}
		} catch (ClassCastException ex)
		{
			// ignore start and end states
		}
	} //

	return("");
	
}
/**
 * Return the AddToListButton property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JButton getAddToListButton() {
	if (ivjAddToListButton == null) {
		try {
			ivjAddToListButton = new javax.swing.JButton();
			ivjAddToListButton.setName("AddToListButton");
			ivjAddToListButton.setText("AddToList");
			ivjAddToListButton.setBounds(125, 334, 95, 25);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjAddToListButton;
}
/**
 * Return the Name property value.
 * @return javax.swing.JTextField
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JTextField getiName() {
	if (ivjName == null) {
		try {
			ivjName = new javax.swing.JTextField();
			ivjName.setName("Name");
			ivjName.setBounds(97, 41, 141, 19);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjName;
}
/**
 * Return the Info property value.
 * @return javax.swing.JTextField
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JTextField getInfo() {
	if (ivjInfo == null) {
		try {
			ivjInfo = new javax.swing.JTextField();
			ivjInfo.setName("Info");
			ivjInfo.setBounds(214, 305, 196, 19);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjInfo;
}
/**
 * Return the InfoLabel property value.
 * @return javax.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JLabel getInfoLabel() {
	if (ivjInfoLabel == null) {
		try {
			ivjInfoLabel = new javax.swing.JLabel();
			ivjInfoLabel.setName("InfoLabel");
			ivjInfoLabel.setText("Information");
			ivjInfoLabel.setBounds(215, 291, 73, 15);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjInfoLabel;
}
/**
 * Return the JFrameContentPane property value.
 * @return javax.swing.JPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JPanel getJFrameContentPane() {
	if (ivjJFrameContentPane == null) {
		try {
			ivjJFrameContentPane = new javax.swing.JPanel();
			ivjJFrameContentPane.setName("JFrameContentPane");
			ivjJFrameContentPane.setLayout(null);
			getJFrameContentPane().add(getType(), getType().getName());
			getJFrameContentPane().add(getInfo(), getInfo().getName());
			getJFrameContentPane().add(getTypeLabel(), getTypeLabel().getName());
			getJFrameContentPane().add(getInfoLabel(), getInfoLabel().getName());
			getJFrameContentPane().add(getAddToListButton(), getAddToListButton().getName());
			getJFrameContentPane().add(getNameLabel(), getNameLabel().getName());
			getJFrameContentPane().add(getPortLabel(), getPortLabel().getName());
			getJFrameContentPane().add(getiName(), getiName().getName());
			getJFrameContentPane().add(getPort(), getPort().getName());
			getJFrameContentPane().add(getReadButton(), getReadButton().getName());
			getJFrameContentPane().add(getRegInfoButton(), getRegInfoButton().getName());
			getJFrameContentPane().add(getReqSource(), getReqSource().getName());
			getJFrameContentPane().add(getRegReqButton(), getRegReqButton().getName());
			getJFrameContentPane().add(getReqInfoButton(), getReqInfoButton().getName());
			getJFrameContentPane().add(getJScrollPane1(), getJScrollPane1().getName());
			getJFrameContentPane().add(getJScrollPane2(), getJScrollPane2().getName());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjJFrameContentPane;
}
/**
 * Return the JList1 property value.
 * @return javax.swing.JList
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JList getJList1() {
	if (ivjJList1 == null) {
		try {
			ivjJList1 = new javax.swing.JList();
			ivjJList1.setName("JList1");
			ivjJList1.setCellRenderer(new MyCellRenderer());
		//	ivjJList1.setAutoscrolls(true);
			ivjJList1.setBounds(0, 0, 425, 174);
			// user code begin {1}
		//	java.util.Vector list1 = new java.util.Vector();
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjJList1;
}
/**
 * Return the JList2 property value.
 * @return javax.swing.JList
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JList getJList2() {
	if (ivjJList2 == null) {
		try {
			ivjJList2 = new javax.swing.JList();
			ivjJList2.setName("JList2");
			ivjJList1.setCellRenderer(new MyCellRenderer2());
		
			ivjJList2.setBounds(0, 0, 160, 120);
			// user code begin {1}
	/*		list2.addElement("123456789");
			list2.addElement("234567891");
			list2.addElement("345678912");
			list2.addElement("456789123");
			list2.addElement("567891234");
			list2.addElement("678912345");
			list2.addElement("789123456");
			list2.addElement("891234567");
			list2.addElement("912345678");
			list2.addElement("123456789");
			list2.addElement("246813579");
			list2.addElement("468235791");
			list2.addElement("682457913");
			list2.addElement("824679135");
			list2.addElement("246891357");
			ivjJList2.setListData(list2);
			*/
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjJList2;
}
/**
 * Return the JScrollPane1 property value.
 * @return javax.swing.JScrollPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JScrollPane getJScrollPane1() {
	if (ivjJScrollPane1 == null) {
		try {
			ivjJScrollPane1 = new javax.swing.JScrollPane();
			ivjJScrollPane1.setName("JScrollPane1");
			ivjJScrollPane1.setBounds(56, 383, 549, 103);
			getJScrollPane1().setViewportView(getJList2());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjJScrollPane1;
}
/**
 * Return the JScrollPane2 property value.
 * @return javax.swing.JScrollPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JScrollPane getJScrollPane2() {
	if (ivjJScrollPane2 == null) {
		try {
			ivjJScrollPane2 = new javax.swing.JScrollPane();
			ivjJScrollPane2.setName("JScrollPane2");
			ivjJScrollPane2.setBounds(54, 83, 436, 204);
			getJScrollPane2().setViewportView(getJList1());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjJScrollPane2;
}
/**
 * Return the NameLabel property value.
 * @return javax.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JLabel getNameLabel() {
	if (ivjNameLabel == null) {
		try {
			ivjNameLabel = new javax.swing.JLabel();
			ivjNameLabel.setName("NameLabel");
			ivjNameLabel.setText("Name");
			ivjNameLabel.setBounds(58, 46, 45, 15);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjNameLabel;
}
/**
 * Return the Port property value.
 * @return javax.swing.JTextField
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JTextField getPort() {
	if (ivjPort == null) {
		try {
			ivjPort = new javax.swing.JTextField();
			ivjPort.setName("Port");
			ivjPort.setBounds(286, 40, 209, 19);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjPort;
}
/**
 * Return the PortLabel property value.
 * @return javax.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JLabel getPortLabel() {
	if (ivjPortLabel == null) {
		try {
			ivjPortLabel = new javax.swing.JLabel();
			ivjPortLabel.setName("PortLabel");
			ivjPortLabel.setText("Port");
			ivjPortLabel.setBounds(258, 45, 45, 15);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjPortLabel;
}
/**
 * Return the ReadButton property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JButton getReadButton() {
	if (ivjReadButton == null) {
		try {
			ivjReadButton = new javax.swing.JButton();
			ivjReadButton.setName("ReadButton");
			ivjReadButton.setText("READ");
			ivjReadButton.setBounds(549, 34, 85, 25);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjReadButton;
}
/**
 * Return the RegInfoButton property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JButton getRegInfoButton() {
	if (ivjRegInfoButton == null) {
		try {
			ivjRegInfoButton = new javax.swing.JButton();
			ivjRegInfoButton.setName("RegInfoButton");
			ivjRegInfoButton.setText("Register Info Source");
			ivjRegInfoButton.setVerticalAlignment(javax.swing.SwingConstants.CENTER);
			ivjRegInfoButton.setBounds(508, 94, 159, 32);
			ivjRegInfoButton.setVerticalTextPosition(javax.swing.SwingConstants.CENTER);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjRegInfoButton;
}
/**
 * Return the RegReqButton property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JButton getRegReqButton() {
	if (ivjRegReqButton == null) {
		try {
			ivjRegReqButton = new javax.swing.JButton();
			ivjRegReqButton.setName("RegReqButton");
			ivjRegReqButton.setText("Register Request");
			ivjRegReqButton.setBounds(511, 214, 158, 29);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjRegReqButton;
}
/**
 * Return the ReqInfoButton property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JButton getReqInfoButton() {
	if (ivjReqInfoButton == null) {
		try {
			ivjReqInfoButton = new javax.swing.JButton();
			ivjReqInfoButton.setName("ReqInfoButton");
			ivjReqInfoButton.setText("Request Info");
			ivjReqInfoButton.setBounds(512, 276, 157, 30);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjReqInfoButton;
}
/**
 * Return the ReqSource property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JButton getReqSource() {
	if (ivjReqSource == null) {
		try {
			ivjReqSource = new javax.swing.JButton();
			ivjReqSource.setName("ReqSource");
			ivjReqSource.setText("Request a Source");
			ivjReqSource.setBounds(510, 153, 157, 30);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjReqSource;
}
/**
 * Return the Type property value.
 * @return javax.swing.JTextField
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JTextField getType() {
	if (ivjType == null) {
		try {
			ivjType = new javax.swing.JTextField();
			ivjType.setName("Type");
			ivjType.setBounds(57, 305, 144, 19);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjType;
}
/**
 * Return the TypeLabel property value.
 * @return javax.swing.JLabel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private JLabel getTypeLabel() {
	if (ivjTypeLabel == null) {
		try {
			ivjTypeLabel = new javax.swing.JLabel();
			ivjTypeLabel.setName("TypeLabel");
			ivjTypeLabel.setText("Type");
			ivjTypeLabel.setBounds(57, 290, 58, 15);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	};
	return ivjTypeLabel;
}
/**
 * Called whenever the part throws an exception.
 * @param exception java.lang.Throwable
 */
private void handleException(Throwable exception) {

	/* Uncomment the following lines to print uncaught exceptions to stdout */
	// System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	// exception.printStackTrace(System.out);
}
/**
 * Initializes connections
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initConnections() {
	// user code begin {1}
	// user code end
//	getAddAgentButton().addActionListener(this);
//	getAddConvButton().addActionListener(this);
//	getAddStateButton().addActionListener(this);
//	getAddTransitionButton().addActionListener(this);
//	getAgentDiagramPage().addMouseListener(this);
//	getAgentDiagramPage().addMouseMotionListener(this);
//	getATTabbedPane().addChangeListener(this);
//	getButtonOne().addActionListener(this);
//	getButtonTwo().addActionListener(this);
	getReadButton().addActionListener(this);
	getRegInfoButton().addActionListener(this); 
	getRegReqButton().addActionListener(this);
	getReqInfoButton().addActionListener(this);
	getReqSource().addActionListener(this);
	getAddToListButton().addActionListener(this);
}
/**
 * Initialize the class.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initialize() {
	// user code begin {1}
	// user code end
	setName("WindowBase");
	setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
	setSize(692, 511);
	setContentPane(getJFrameContentPane());
	// user code begin {2}
	initConnections();
	// user code end
}
/**
 * main entrypoint - starts the part when it is run as an application
 * @param args java.lang.String[]
 */
public static void main(java.lang.String[] args)
{
	try
	{
		WindowBase aWindowBase = new WindowBase();
		aWindowBase.run();
	} catch (Throwable exception)
	{
		System.err.println("Exception occurred in main() of com.sun.java.swing.JFrame");
		exception.printStackTrace(System.out);
	}
}
/**
 * This method was created in VisualAge.
 */
public void read()
{
	parent.name = getiName().getText();
	parent.port = Integer.parseInt(getPort().getText());
}
/**
 * This method was created in VisualAge.
 */
public void regInfo()
{
	Information info = (Information) getJList1().getSelectedValue(); //

	Thread init = new Thread(new Client_Register_Info_Source(parent, parent.serverHost, parent.serverPort, info.type));
	init.start();
}
/**
 * This method was created in VisualAge.
 */
public void requestInfo() {
	SourceInfo sInfo = (SourceInfo)getJList2().getSelectedValue();
	Source source = sInfo.source;

	/* print to console */
	System.out.println("type...     " + sInfo.type);
	System.out.println("agentName..." + source.agentName);
	System.out.println("Host...		" + source.host);
	System.out.println("Port...		" + source.port);
	System.out.println("    ... start conversation to request info ... ");

	/* start conversation to ask for info */
	Thread init = new Thread(new Requestor_Request_Info(parent, source.host, source.port, sInfo.type));
	init.start();
}
/**
 * This method was created in VisualAge.
 */
public void run()
{
	try
	{
		Class aCloserClass = Class.forName("com.ibm.uvm.abt.edit.WindowCloser");
		Class parmTypes[] = {java.awt.Window.class};
		Object parms[] = {this};
		java.lang.reflect.Constructor aCtor = aCloserClass.getConstructor(parmTypes);
		aCtor.newInstance(parms);
	} catch (java.lang.Throwable exc)
	{
	};
	setVisible(true);
}
}
