/*
 * @(#)ServerMulticast.java
 * FileSharing package
 * MSE Project: Applying Broadcast/Multicast/Secured Communication to agentMom
 * Department of Computing and Information Sciences
 * Kansas State University
 */
package ksu.cis.example.FileSharing;
import ksu.cis.mom.*;
import java.net.*;
import java.io.*;

/**
 * @author Chairoj Mekprasertvit
 *
 */
public class ServerMulticast extends MulticastConversation
{
  private String fileName;
  private String conversation_name;
  private ServerAgent parent;
  private String client;
  private boolean isDone = false;
  
  public ServerMulticast(
    ServerAgent a,
    int port,
    InetAddress group,
    String req,
    String client)
  {
    super(a, group, port, a.multicast_queue);
    parent = a;
    this.fileName = req;
    this.conversation_name = "ServerMulticast";
    this.client = client;
  }
  
  public boolean getDone()
  {
    return isDone;
  }
  
  public void run()
  {
    Message m = new Message();
    int state = 0;
    boolean notDone = true;
    try
    {
      while (notDone)
      {
        switch (state)
        {
          case 0 :
            m.performative = "find file";
            InfoObject info = new InfoObject(fileName, client);
            m.content = info;
            startConversation(m, conversation_name, "Server");
            state = 1;
            break;
          case 1 :
            notDone = true;
            isDone = true;
        }
      }
    }
    catch (IOException e)
    {
      parent.write("** IO Exception in multicast conversation.");
    }
  }
}
