/*
 * @(#)ServerRespondRequest.java
 * FileSharing package
 * MSE Project: Applying Broadcast/Multicast/Secured Communication to agentMom
 * Department of Computing and Information Sciences
 * Kansas State University
 */
package ksu.cis.example.FileSharing;
import java.net.*;
import ksu.cis.mom.*;
import java.io.*;

/**
 * @author Chairoj Mekprasertvit
 *
 */
public class ServerRespondRequest extends Conversation
{
  private ServerAgent parent;
  private boolean isDone = false;
  
  public ServerRespondRequest(
  Socket s,
  ObjectInputStream i,
  ObjectOutputStream o,
  ServerAgent a,
  Message m)
  {
    super(s, i, o, a, m);
    parent = a;
  }
  
  public boolean getDone()
  {
    return isDone;
  }
  
  public void run()
  {
    int state = 0;
    boolean notDone = true;
    int result = 0;
    try
    {
      while (notDone)
      {
        switch (state)
        {
          case 0 :
            Message reply = new Message();
            reply.setPerformative("reply");
            reply.setContent("accepted");
            this.sendMessage(reply, output);
            state = 1;
            break;
          case 1 :
            notDone = false;
            break;
        }
      }
      input.close();
      output.close();
      connection.close();
      isDone = true;
    }
    catch (UnknownHostException e)
    {
      parent.write("** Unknown Host exception in Client_Register.");
    }
    catch (EOFException oef)
    {
      parent.write("** Server terminated connection in Client_Register.");
    }
    catch (IOException e)
    {
      parent.write("** IO Exception in Client_Register.");
    }
  }
}
