/*
 * @(#)DistributorAgentGUI.java
 * KeyDistribution package
 * MSE Project: Applying Broadcast/Multicast/Secured Communication to agentMom
 * Department of Computing and Information Sciences
 * Kansas State University
 */
package ksu.cis.example.KeyDistribution;
import java.awt.*;
import java.awt.event.*;

/**
 * <p>Class DistributorAgentGUI is a user interface for DistributorAgent class 
 * that displays information on TextArea when agent sends or receives message 
 * to or from other agents.
 * @author Scott DeLoach and Chairoj Mekprasertvit
 * @version 1.0, 01/21/2004
 */

public class DistributorAgentGUI extends Frame
{
  private TextArea display;
  private DistributorAgent agent;
  
  public DistributorAgentGUI(String name, String broadcastAddress)
  {
    super("Please Wait...");
    setLayout (new BorderLayout());
    display = new TextArea();
    add(display, "Center");
    display.setBackground(Color.white);
    display.setForeground(Color.black);
    
    setSize(300, 200);
    
    setVisible(true);
    show();

    agent = new DistributorAgent(name, broadcastAddress, this);
    Thread t = new Thread(agent);
    t.start();
  }
  
  public void startUI()
  {
    setTitle("Demo III: " + agent.name);
  }
  
  public void setDisplay(String m)
  {
    display.append(m + "\n");
    System.out.println(m);
  }
  
  /**
   * main method
   * @param args
   */
  public static void main(String[] args)
  {
    if(args.length != 2)
    {
      System.out.println("Usage: java DistributorAgentGUI <name> <broadcast address>");
      System.exit(1);
    }
    String name = args[0];
    String broadcastAddress = args[1];
    DistributorAgentGUI gui = new DistributorAgentGUI(name, broadcastAddress);
    gui.addWindowListener
    (
      new WindowAdapter()
      {
        public void windowClosing(WindowEvent e)
        {
          System.exit(0);
        }
      }
    );
    gui.startUI();
  }// end of main method
  
}
