/*
 * Project: Applying Broadcast/Multicast/Secured Communication to agentMom
 * Department of Computing and Information Sciences
 * Kansas State University
 *
 */
package ksu.cis.test;
import java.net.*;
import ksu.cis.mom.*;
import java.io.*;
import java.util.*;

/**
 * @author Chairoj Mekprasertvit
 *
 */
public class MulticastServer extends MulticastConversation
{
  public agentServer parent;
  public String command;
  public MulticastServer(
    MulticastSocket mSocket,
    Vector queue,
    agentServer a,
    int m_port,
    Message m)
  {
    super(a, a.group[0], m_port, queue, m);
    parent = a;
  }
  public void run()
  {
    boolean notDone = true;
    int state = 0;
    int result = 0;
    while (notDone)
    {
      switch (state)
      {
        case 0 :
          command = (String) m.content;
          CalculatePrime cp = new CalculatePrime();
          if (m.performative.equals("calculate"))
          {
            result = cp.getPrime(Integer.parseInt(command));
            System.out.println("Result is " + result);
          }
          else
            result = -1;
          state = 1;
          break;
        case 1 :
          Message reply = new Message();
          reply.setPerformative("reply");
          command = "Prime is " + result;
          reply.setContent(command);
          try
          {
            sendMessage(reply, "MulticastServer", "multicast");
          }
          catch (IOException ioex)
          {
            parent.write(ioex.toString());
          }
          notDone = false;
          break;
        default :
          parent.write("** Error in MulticastServer **");
          break;
      }

    }
  }

}
